/******************************************************************************

********************************* ļò ********************************

******************************************************************************/

#include "W25QXX.h"

/******************************************************************************

*********************************     *********************************

******************************************************************************/

/*---------------------* 

*     ݶ()

*----------------------*/

uint8_t W25X_Buffer[W25X_SECTOR_SIZE];

volatile bool sem_W25X_DMA_Busy = true;

volatile bool sem_W25X_DMA_RxRdy= false;

/*---------------------* 

*       ݶ(ڲ) 

*----------------------*/

//static uint8_t  W25X_TX_Byte=0xFF;

/******************************************************************************

*********************************     **********************************

******************************************************************************/

/******************************************************************************

/ :ʼW25QXX

/ ޸:2013/9/10 19:04:16

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

void W25X_Init(void)

{
	/* Private typedef ---------------------------------------------------------*/

	GPIO_InitTypeDef GPIO_InitStruct;
	SPI_InitTypeDef  SPI_InitStructure ;
	
	/** SPI1 GPIO Configuration	

		 PA5	 ------> SPI1_SCK

		 PA6	 ------> SPI1_MISO

		 PA7	 ------> SPI1_MOSI

	*/

	/*Enable or disable APB2 peripheral clock */

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

	/*Configure GPIO pin */

	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7;

	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF_PP;

	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;

	GPIO_Init(GPIOA, &GPIO_InitStruct);

	/** Configure pins as GPIO

		 PA4	 ------> GPIO_Output

		 PB0	 ------> GPIO_Output

	*/

	/*Enable or disable APB2 peripheral clock */

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

	W25X_CS_H();

	/*Configure GPIO pin */

	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_4;

	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_Out_PP;

	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;

	GPIO_Init(GPIOA, &GPIO_InitStruct);

	GPIO_PinLockConfig(GPIOA,GPIO_Pin_4);

	//ʼSPIʱ	

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1,ENABLE);

	// SPI

	SPI_Cmd(SPI1,DISABLE);

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex ;

	SPI_InitStructure.SPI_Mode = SPI_Mode_Master ;

	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b ;

	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low ;

	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge ;

	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft ;

	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_4 ;    //72MHzƵ

	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB ; //SPIóLSBģʽ

	SPI_InitStructure.SPI_CRCPolynomial = 7 ;

	SPI_Init( SPI1, &SPI_InitStructure ) ;

	SPI_Cmd(SPI1,ENABLE);           //SPI
}

/******************************************************************************

/ :SPIһֽڵ

/ ޸:2013/9/10 19:04:16

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

uint8_t W25X_ReadWriteByte(uint8_t dat)

{

    while ((SPI1->SR & SPI_I2S_FLAG_TXE) == (uint16_t)RESET);

    SPI1->DR = dat;

    while ((SPI1->SR & SPI_I2S_FLAG_RXNE) == (uint16_t)RESET);

    return (SPI1->DR);

}

/******************************************************************************

/ :ȡSPI_FLASH״̬Ĵ

/ ޸:2013/9/10 20:38:48

/ :none

/ :none

/ ʹ˵:none

/   BIT7  6   5   4   3   2   1   0

/   SPR   RV  TB BP2 BP1 BP0 WEL BUSY

/

/   SPR:Ĭ0,״̬Ĵλ,WPʹ

/   TB,BP2,BP1,BP0:FLASHд

/   WEL:дʹ, 1

/   BUSY:æλ(1,æ;0,)

/   Ĭ:0x00

******************************************************************************/

uint8_t W25X_ReadSR(void)   

{  

    uint8_t byte=0;   

    W25X_CS_L();                            //ʹ   

    W25X_ReadWriteByte(W25X_ReadStatusReg); //Ͷȡ״̬Ĵ    

    byte=W25X_ReadWriteByte(0Xff);          //ȡһֽ  

    W25X_CS_H();                            //ʹ     

    return byte;   

}

/******************************************************************************

/ :ȡоƬID

/ ޸:2013/9/10 20:43:20

/ :none

/ :

/   ֵ:       

/   0XEF13,ʾоƬͺΪW25Q80  

/   0XEF14,ʾоƬͺΪW25Q16    

/   0XEF15,ʾоƬͺΪW25Q32  

/   0XEF16,ʾоƬͺΪW25Q64 

/   0XEF17,ʾоƬͺΪW25Q128 

/ ʹ˵:none

******************************************************************************/     

uint16_t W25X_ReadID(void)

{

    uint16_t Temp = 0;

      

    W25X_CS_L();       

    W25X_ReadWriteByte(0x90);       //ͶȡID     

    W25X_ReadWriteByte(0x00);      

    W25X_ReadWriteByte(0x00);      

    W25X_ReadWriteByte(0x00);         

    Temp|=W25X_ReadWriteByte(0xFF)<<8;  

    Temp|=W25X_ReadWriteByte(0xFF);  

    W25X_CS_H();        

    return Temp;

} 

/******************************************************************************

/ :ȴоƬִ

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

void W25X_Wait_Busy(void)

{

    while((W25X_ReadSR()&0x01)==0x01);   // ȴBUSYλ 

}

/******************************************************************************

/ :ȡоƬǷΪæ

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

bool W25X_Read_BusyState(void)

{

    if((W25X_ReadSR()&0x01))return true;

    else return false;  

}

/******************************************************************************

/ :ʹSPI FLASH 

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

void SPI_Flash_PowerDown(void)   

{ 

    uint16_t i;

        

    W25X_CS_L();                        //ʹ   

    W25X_ReadWriteByte(W25X_PowerDown); //͵  

    W25X_CS_H();                        //ȡƬѡ            

    i= (72)*3;while(i--);               //ȴԼ3us

}

/******************************************************************************

/ :SPI FLASH

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/ 

void SPI_Flash_WakeUp(void)   

{ 

    uint16_t i;

    

    W25X_CS_L();                        //ʹ   

    W25X_ReadWriteByte(W25X_ReleasePowerDown); //͵  

    W25X_CS_H();                        //ȡƬѡ

    i= (72)*3;while(i--);               //ȴԼ3us

}

/******************************************************************************

/ :оƬ ,ȴʱ䳬... 

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

void W25X_Erase_Chip(bool bwait)   

{                                   
	
    W25X_Wait_Busy();   

    W25X_CS_L();                    //ʹ   

    W25X_ReadWriteByte(W25X_ChipErase);   //Ƭ  

    W25X_CS_H();                    //ȡƬѡ

    if(bwait)W25X_Wait_Busy();      //ȴоƬ

}

/******************************************************************************

/ :һ

/ ޸:2013/9/10 20:43:20

/ :Dst_Addr:ַ ʵ

/ :none

/ ʹ˵:noneһʱ:65ms

******************************************************************************/

void W25X_Erase_Sector(uint32_t Dst_Addr,bool bwait)   

{  

    W25X_Wait_Busy();   

    W25X_CS_L();                    //ʹ    

    W25X_ReadWriteByte(W25X_SectorErase);           //ָ 

    W25X_ReadWriteByte((uint8_t)((Dst_Addr)>>16));  //24bitַ    

    W25X_ReadWriteByte((uint8_t)((Dst_Addr)>>8));   

    W25X_ReadWriteByte((uint8_t)Dst_Addr);  

    W25X_CS_H();                    //ȡƬѡ

    if(bwait)W25X_Wait_Busy();      //ȴ

} 

/******************************************************************************

/ :һҳ,

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

void W25X_Read_Page(uint8_t * pBuffer,uint32_t PageAddr)

{

    uint32_t    ReadAddr;

    uint16_t    i;

    

    if(PageAddr < W25X_PAGE_NUM)

    {               

        ReadAddr = PageAddr *W25X_PAGE_SIZE;

        W25X_CS_L();  

        W25X_ReadWriteByte(W25X_ReadData);         //Ͷȡ   

        W25X_ReadWriteByte((uint8_t)((ReadAddr)>>16));  //24bitַ    

        W25X_ReadWriteByte((uint8_t)((ReadAddr)>>8));   

        W25X_ReadWriteByte((uint8_t)ReadAddr);   

        for(i=0;i<W25X_PAGE_SIZE;i++)

        { 

            pBuffer[i]=W25X_ReadWriteByte(0XFF);   //ѭ  

        }

        W25X_CS_H();    

    }

}

/******************************************************************************

/ :дһҳݵָҳ,ҳѱ!!!

/ ޸:2013/9/10 20:43:20

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/ 

void W25X_Write_Page(uint8_t * pBuffer,uint32_t PageAddr)

{

    uint16_t    i; 

    uint32_t    WriteAddr;

    W25X_Wait_Busy();      //ȴ

    

    //дFLASH

    WriteAddr =PageAddr* W25X_PAGE_SIZE;

    W25X_CS_L(); 

    W25X_ReadWriteByte(W25X_PageProgram);      //дҳ   

    W25X_ReadWriteByte((uint8_t)((WriteAddr)>>16)); //24bitַ    

    W25X_ReadWriteByte((uint8_t)((WriteAddr)>>8));   

    W25X_ReadWriteByte((uint8_t)WriteAddr);   

    for(i=0;i<W25X_PAGE_SIZE;i++)W25X_ReadWriteByte(pBuffer[i]);//ѭд  

    W25X_CS_H();

    //W25X_Wait_Busy();      //ȴ

}

/******************************************************************************

/ :ַָʼȡָȵ(64KBֽ),ȡģʽ

/ ޸:2013/9/10 20:43:20

/ :

/   pBuffer:ݴ洢

/   ReadAddr:ʼȡĵַ(24bit)

/   NumByteToRead:Ҫȡֽ(65535)

/ :none

/ ʹ˵:none

******************************************************************************/ 

void W25X_Read_Data(uint8_t * pBuffer,uint32_t ReadAddr,uint16_t NumByteToRead)   

{ 

    uint16_t i;                 

    W25X_CS_L();  

    W25X_ReadWriteByte(W25X_ReadData);         //Ͷȡ   

    W25X_ReadWriteByte((uint8_t)((ReadAddr)>>16));  //24bitַ    

    W25X_ReadWriteByte((uint8_t)((ReadAddr)>>8));   

    W25X_ReadWriteByte((uint8_t)ReadAddr);   

    for(i=0;i<NumByteToRead;i++)

    { 

        pBuffer[i]=W25X_ReadWriteByte(0XFF);   //ѭ  

    }

    W25X_CS_H();                 

}

/******************************************************************************

/ :ΨһID,8ֽ

/ ޸:2013/9/11 9:38:49

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/

void W25X_Read_UID(uint8_t * pBuffer)

{ 

    uint8_t i;

    W25X_CS_L();       

    W25X_ReadWriteByte(W25X_ReadUniqueID);    

    W25X_ReadWriteByte(0x00);      

    W25X_ReadWriteByte(0x00);      

    W25X_ReadWriteByte(0x00);

    W25X_ReadWriteByte(0x00);        

    for(i=0;i<8;i++)

        pBuffer[i]=W25X_ReadWriteByte(0XFF);   //ѭ

    W25X_CS_H();

}

/******************************************************************************

/ :W25Xⲿ¼ƣƬ

/ ޸:2013/9/11 9:38:49

/ :none

/ :none

/ ʹ˵:none

******************************************************************************/
void W25X_Outside(void)

{
	GPIO_InitTypeDef GPIO_InitStruct;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

	GPIO_InitStruct.GPIO_Pin = GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7;

	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_IPU;

	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;

	GPIO_Init(GPIOA, &GPIO_InitStruct);

	W25X_CS_H();
	
	while(1);
}
